this.name        = "Hyperdrives"; 
this.author      = "Redspear"; 
this.copyright   = "2016 Redspear";
this.licence     = "CC BY-NC-SA 4.0"; 
this.description = "Variable hyperdrives and jump ranges for player ships"; 
this.version     = "0.7";

"use strict";

// determine player ship hyperdrive range

this.startUp = this.playerBoughtNewShip = this.equipmentAdded = this.equipmentRemoved = this.equipmentDamaged = this.equipmentRepaired = function()
{
	//	EASY-TWEAK section - note the advice (or not, none of my business really...)
	//	below 7, ONLY ADJUST IN INCREMENTS OF 0.4 from 0 or you might get undesired results (so that's: 0; 0.4; 0.8 etc.)
	
	var maxRange = 7; //	7 is the max value and also represents the typical elite/oolite experience
	var longRange = 6.4;	//	almost always the greatest distance for a jump is 6.8 LY, so this should probably be a lower value than that
	var shortRange = 6;	//	(effectively 6.0) the minimum to make every system accessible from somewhere in galaxy 1
	var minRange = 5.6;	//	(effectively 5.6) will make it possible to get to lots of places but it might require taking the long way round
	
	//	ILLICIT UNLOCK tweakery (comments assume that the above values are unchanged, again use increments of 0.4)
	
	var noPen = 0;	//	minimum capability to make it to Zaonce and beyond from start
	var minPen = -0.4;
	var tokenPen = -0.8;	
	var lightPen = -1.2;	//	minimum capability to make it to Reorte and beyond from start
	var lowPen = -1.6;	//	minimum capability to make it to Zaonce and beyond (with upgrades)
	var medPen = -2;	//	minimum capability to reach and exploit the Leesti-Diso milk run at start
	var highPen = -2.4;
	var heavyPen = -2.8;	//	minimum capability to make it to Reorte and beyond (with upgrades)
	var harshPen = -3.2;	//	minimum capability to reach and exploit the Leesti-Diso milk run (with upgades)
	var maxPen = -5.6;	//	effectively no hyperdrive (in most situations)
	
	var rangePen = noPen;	//	this value must be set somewhere, independant of illicit unlock
	
	if (player.ship.name == "Constrictor")
		{rangePen = noPen;
	}
		
	if (player.ship.name == "Gecko")
		{rangePen = highPen;
	}
			
	if (player.ship.name == "Krait")
		{rangePen = lowPen;
	}
							
	if (player.ship.name == "Mamba")
		{rangePen = lightPen;
	}
	
	if (player.ship.name == "Mamba Escort")
		{rangePen = lowPen;
	}
	
	if (player.ship.name == "Sidewinder")
		{rangePen = medPen;
	}
		
	if (player.ship.name == "Sidewinder Escort")
		{rangePen = highPen;
	}
		
	if (player.ship.name == "Viper")
		{rangePen = heavyPen;
	}
		
	if (player.ship.name == "Viper Interceptor")
		{rangePen = noPen;
	}
		
	if (player.ship.name == "Viper Pursuit")
		{rangePen = tokenPen;
	}
		
	if (player.ship.name == "Orbital Shuttle")
		{rangePen = maxPen;
	}
		
	if (player.ship.name == "Transporter")
		{rangePen = minPen;
	}
		
	if (player.ship.name == "Transporter Miner")
		{rangePen = tokenPen;
	}
		
	if (player.ship.name == "Worm")
		{rangePen = harshPen;
	}
		
	if (player.ship.name == "Worm Miner")
		{rangePen = maxPen;
	}
		
	
	//	equipment modifiers (EEU, ANA, WHScanner & GalDrive dictate jump range capability)
	
	if	(player.ship.equipmentStatus("EQ_ENERGY_UNIT") === "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_GAL_DRIVE") === "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_WORMHOLE_SCANNER") === "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_ADVANCED_NAVIGATIONAL_ARRAY") === "EQUIPMENT_OK")
		{var rangeBoost = maxRange;
		}
		
	if	(player.ship.equipmentStatus("EQ_ENERGY_UNIT") === "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_GAL_DRIVE") === "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_WORMHOLE_SCANNER") === "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_ADVANCED_NAVIGATIONAL_ARRAY") != "EQUIPMENT_OK")
		{var rangeBoost = maxRange;
		}
		
	if	(player.ship.equipmentStatus("EQ_ENERGY_UNIT") != "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_GAL_DRIVE") === "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_WORMHOLE_SCANNER") === "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_ADVANCED_NAVIGATIONAL_ARRAY") === "EQUIPMENT_OK")
		{var rangeBoost = maxRange;
		}
		
	if	(player.ship.equipmentStatus("EQ_ENERGY_UNIT") != "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_GAL_DRIVE") === "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_WORMHOLE_SCANNER") === "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_ADVANCED_NAVIGATIONAL_ARRAY") != "EQUIPMENT_OK")
		{var rangeBoost = longRange;
		}		
		
	if	(player.ship.equipmentStatus("EQ_ENERGY_UNIT") === "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_GAL_DRIVE") != "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_WORMHOLE_SCANNER") === "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_ADVANCED_NAVIGATIONAL_ARRAY") === "EQUIPMENT_OK")
		{var rangeBoost = maxRange;
		}	

	if	(player.ship.equipmentStatus("EQ_ENERGY_UNIT") === "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_GAL_DRIVE") != "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_WORMHOLE_SCANNER") === "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_ADVANCED_NAVIGATIONAL_ARRAY") != "EQUIPMENT_OK")
		{var rangeBoost = longRange;
		}			
	
	if	(player.ship.equipmentStatus("EQ_ENERGY_UNIT") === "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_GAL_DRIVE") === "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_WORMHOLE_SCANNER") != "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_ADVANCED_NAVIGATIONAL_ARRAY") === "EQUIPMENT_OK")
		{var rangeBoost = maxRange;
		}
		
	if	(player.ship.equipmentStatus("EQ_ENERGY_UNIT") === "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_GAL_DRIVE") === "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_WORMHOLE_SCANNER") != "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_ADVANCED_NAVIGATIONAL_ARRAY") != "EQUIPMENT_OK")
		{var rangeBoost = longRange;
		}		
		
	if	(player.ship.equipmentStatus("EQ_ENERGY_UNIT") === "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_GAL_DRIVE") != "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_WORMHOLE_SCANNER") != "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_ADVANCED_NAVIGATIONAL_ARRAY") === "EQUIPMENT_OK")
		{var rangeBoost = longRange;
		}	
		
	if	(player.ship.equipmentStatus("EQ_ENERGY_UNIT") === "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_GAL_DRIVE") != "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_WORMHOLE_SCANNER") != "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_ADVANCED_NAVIGATIONAL_ARRAY") != "EQUIPMENT_OK")
		{var rangeBoost = shortRange;
		}		
	
	if	(player.ship.equipmentStatus("EQ_ENERGY_UNIT") != "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_GAL_DRIVE") === "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_WORMHOLE_SCANNER") != "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_ADVANCED_NAVIGATIONAL_ARRAY") === "EQUIPMENT_OK")
		{var rangeBoost = longRange;
		}
		
	if	(player.ship.equipmentStatus("EQ_ENERGY_UNIT") != "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_GAL_DRIVE") === "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_WORMHOLE_SCANNER") != "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_ADVANCED_NAVIGATIONAL_ARRAY") != "EQUIPMENT_OK")
		{var rangeBoost = shortRange;
		}		
		
	if	(player.ship.equipmentStatus("EQ_ENERGY_UNIT") != "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_GAL_DRIVE") != "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_WORMHOLE_SCANNER") === "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_ADVANCED_NAVIGATIONAL_ARRAY") === "EQUIPMENT_OK")
		{var rangeBoost = longRange;
		}	
		
	if	(player.ship.equipmentStatus("EQ_ENERGY_UNIT") != "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_GAL_DRIVE") != "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_WORMHOLE_SCANNER") === "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_ADVANCED_NAVIGATIONAL_ARRAY") != "EQUIPMENT_OK")
		{var rangeBoost = shortRange;
		}		

	if	(player.ship.equipmentStatus("EQ_ENERGY_UNIT") != "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_GAL_DRIVE") != "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_WORMHOLE_SCANNER") != "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_ADVANCED_NAVIGATIONAL_ARRAY") === "EQUIPMENT_OK")
		{var rangeBoost = shortRange;
		}
		
	if	(player.ship.equipmentStatus("EQ_ENERGY_UNIT") != "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_GAL_DRIVE") != "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_WORMHOLE_SCANNER") != "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_ADVANCED_NAVIGATIONAL_ARRAY") != "EQUIPMENT_OK")
		{var rangeBoost = minRange;
		}
		
	this._rangeLimit = rangeBoost + rangePen;
	log(this.name, "rangeBoost " + rangeBoost);
	log(this.name, "rangePen " + rangePen);
	log(this.name, "rangeLimit " + _rangeLimit);
	log(this.name, "fuel " + player.ship.fuel);
	log(this.name, "ship " + player.ship.name);	
}

this.startUpComplete = function ()
{
	this._fuelMalus = 0;	//	needed for navigation charts
}

// represent range limits on navigation charts

this.guiScreenChanged = function(toGUI)
{
	if (toGUI == "GUI_SCREEN_SHORT_RANGE_CHART")
		{if (_fuelMalus == 0 && player.ship.fuel > _rangeLimit)
			{log(this.name, "rangeLimit " + _rangeLimit);
			this._fuelMalus = player.ship.fuel - _rangeLimit - 0.3;	//	range circle may not exceed jump limit
			player.ship.fuel = _rangeLimit + 0.3;	//	temporary fuel 'loss'
			log(this.name, "fuel " + player.ship.fuel);
			log(this.name, "rangeLimit " + _rangeLimit);
			}
		else
		{player.ship.fuel = player.ship.fuel;
		this._fuelMalus = _fuelMalus;}	//	as you were...
	}
		
	if (toGUI != "GUI_SCREEN_SHORT_RANGE_CHART" && toGUI != "GUI_SCREEN_LONG_RANGE_CHART")	
		{player.ship.fuel = player.ship.fuel + _fuelMalus;	//	any 'lost' fuel restored
		this._fuelMalus = 0;}	//	reset fuel 'debt'
}

// abort jump if range limit exceeded

this.playerStartedJumpCountdown = function(standard)
{

	if (System.infoForSystem(galaxyNumber, system.ID).distanceToSystem(System.infoForSystem(galaxyNumber, player.ship.nextSystem)) > _rangeLimit + 0.1)
		{player.ship.cancelHyperspaceCountdown();
		player.consoleMessage ("Present Hyperdrive Capability Insufficient");}	//	let player know what went wrong (or at least give them a clue)
}